<template>
  <div :class="typeTable + '-table-list'">
    <vue-table
      ref="vuetable"
      :fields="fieldTable"
      :api-mode="false"
      :data="itemCurrentPage"
      :css="cssTable.table"
      @vuetable:row-clicked="clickRow"
    ></vue-table>
    <div class="paginate" v-show="totalPage && totalPage > 1">
      <paginate
        class="row-paginate"
        :page-count="totalPage"
        :click-handler="paginate"
        :prev-text="'<'"
        :next-text="'>'"
        :container-class="'className'"
        :next-class="'nextBtn'"
        :page-class="'pageBtn'"
        :prev-class="'prevBtn'"
      >
      </paginate>
    </div>
  </div>
</template>

<script>
import VueTable from "vuetable-2";
import Paginate from "vuejs-paginate";
import { apiCustomerGet } from "../../services/baseApi";
import moment from "moment";

const cssTable = {
  table: {
    tableWrapper: "table-responsive",
    tableHeaderClass: "",
    tableBodyClass: "",
    tableClass: "table table-hover table-striped table-borderless",
    loadingClass: "",
    ascendingIcon: "",
    descendingIcon: "",
    ascendingClass: "",
    descendingClass: "",
    sortableIcon: "",
    handleIcon: ""
  }
};

export default {
  components: {
    VueTable,
    Paginate
  },
  props: {
    typeTable: String
  },
  data() {
    return {
      fieldTable: ["creater", "title", "date", "reward"],
      user: {},
      cssTable,
      totalPage: 1,
      page: 1,
      totalGame: [],
      itemCurrentPage: [],
      perPage: 10
    };
  },
  methods: {
    async getListGame(typeTable = "quiz") {
      try {
        let res = await apiCustomerGet(typeTable === "quiz" ? "quizz" : "survey");
        if (res && res.data && res.data && res.data.status) {
          let listData = res.data.data.listResult;
          listData = listData.map((item) => {
            let { description: title, createdAt: date, creater } = item;

            title = title.length >= 18 ? title.slice(0, 18) + "..." : title;

            return {
              title,
              creater,
              reward: `${item.reward_btc} BTC - ${item.reward_bsbt} BSBT`,
              date: moment(date, "X").format("MM/DD/YYYY"),
              status: item.approve ? "Approved" : "Pending",
              type: item.type == 2 ? "Yes/No" : "Choose Answer"
            };
          });
          this.totalPage = Math.ceil(listData.length / this.perPage);
          this.totalGame = listData;
          this.getItemCurrentPage();
        }
      } catch (error) {
        console.log(error);
      }
    },
    getItemCurrentPage() {
      let indStart = (this.page - 1) * this.perPage;
      let indEnd = this.page * this.perPage;

      console.log("run", indStart, indEnd);
      this.itemCurrentPage = this.totalGame.slice(indStart, indEnd);
    },
    paginate(page) {
      this.page = page;
      this.getItemCurrentPage();
    },
    prevPage() {
      if (this.page == 1) return;
      this.page -= 1;
      this.getItemCurrentPage();
    },
    clickRow(e) {
      console.log(e.data)
      if (this.typeTable === 'survey' && e.data) {
        this.$router.push(`/survey-play/?survey=${JSON.stringify(e.data)}`);
      }
    }
  },
  mounted() {
    const user = localStorage.getItem("user") || "{}";
    this.user = JSON.parse(user);

    if (this.typeTable === "survey") {
      let listData = [
        {
          id: 77,
          createdAt: 1615886355,
          updatedAt: 1615886355,
          question: "What is your favorite social media platform?",
          expiredAt: 1615914000,
          reward: 1,
          image: "",
          isHighlight: false,
          answer1: "Tiktok",
          answer2: "Facebook",
          answer3: "Instagram",
          answer4: "Twitter",
          isPrized: false,
          descriptionAnswer: "어떻게 동작하는건가",
          created_by: "어떻게"
        }
      ];
      
      listData = listData.map(item => {
        let { id, createdAt: date, question: title, reward, created_by: creater, answer1, answer2, answer3, answer4 } = item;

        title = title.length > 20 ? title + "..." : title;

        return {
          id,
          date: date && moment.unix(date).format("DD/MM/YYYY"),
          title,
          reward,
          creater,
          answer1,
          answer2,
          answer3,
          answer4,
        }
      })
      this.totalPage = Math.ceil(listData.length / this.perPage);
      this.totalGame = listData;
      this.getItemCurrentPage();
      return;
    }

    this.getListGame(this.typeTable);
  }
};
</script>

<style>
.nextBtn,
.prevBtn {
  color: gray;
  font-weight: 700;
  outline: none;
}
.nextBtn a,
.prevBtn a {
  outline: none;
}
.pageBtn {
  border: 1px solid grey;
  border-radius: 5px;
  padding: 0px 7px;
  margin: 0px 5px;
  outline: none;
}
.pageBtn a {
  outline: none;
  color: unset;
  text-decoration: none;
}
</style>

<style scoped>
.vuetable {
  min-height: 150px;
}
.paginate {
  position: relative;
  margin-bottom: 20px;
}
.paginate >>> li {
  padding: 0;
  width: 26px;
}
.paginate >>> li a {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
}
.paginate >>> li.active {
  background: #dc4534;
}
.paginate >>> li.active a {
  color: #fff;
}
.row-paginate {
  display: flex;
  list-style-type: none;
  position: absolute;
  right: 0;
}
/* Table style */
* >>> table thead {
  background: rgba(220, 69, 52, 1);
}
* >>> table thead th {
  padding: 22px 12px;
  color: #fff;
}
.survey-table-list >>> tbody tr {
  cursor: pointer;
}
</style>
